package taghttp

import (
	"fmt"
	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	tagdomain "legalgo-BE-go/internal/domain/tag"
	tagsvc "legalgo-BE-go/internal/services/tag"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"
	"net/http"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Update(
	router chi.Router,
	validate *validator.Validate,
	tagSvc tagsvc.Tag,
) {
	router.
		With(authmiddleware.Authorize()).
		Put("/tag/{tag_id}/update", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()
			tagID := chi.URLParam(r, "tag_id")

			if tagID == "" {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					fmt.Errorf("tag id is not provided"),
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"tag id is not provided",
				)
				return
			}

			var spec tagdomain.TagReq
			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal body",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := tagSvc.Update(tagID, spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "update tag success",
			})
		})
}
